package ePurse;

import javacard.framework.*;

public class EPurse extends Applet {
	
	public final static byte EPURSE_CLA = (byte)0xC0;
	public final static byte EPURSE_ADD = (byte)0xB0;
	public final static byte EPURSE_SUB = (byte)0xB2;
	public final static byte EPURSE_BAL = (byte)0xB4;
	
	private short balance;
	
	public EPurse(){
		balance = (short)0;
	}
	
	public static void install(byte []bAr, short bOff, byte bLen){
		EPurse purse = new EPurse();
		purse.register();
	}
	
	public boolean select(){
		return true;
	}
	
	public void process(APDU apdu){
		byte []buffer = apdu.getBuffer();
		
		if(buffer[ISO7816.OFFSET_CLA] == ISO7816.CLA_ISO7816 &&
			buffer[ISO7816.OFFSET_INS] == ISO7816.INS_SELECT)
		return;
		
		if(buffer[ISO7816.OFFSET_CLA] != EPURSE_CLA)
			ISOException.throwIt(ISO7816.SW_CLA_NOT_SUPPORTED);
		
		short amount = (short)0;
		switch(buffer[ISO7816.OFFSET_INS]){
			case EPURSE_ADD:
				apdu.setIncomingAndReceive();
				amount = Util.getShort(buffer,ISO7816.OFFSET_CDATA);
				balance += amount;
				break;
			case EPURSE_SUB:
				apdu.setIncomingAndReceive();
				amount = Util.getShort(buffer,ISO7816.OFFSET_CDATA);
				if(amount<=balance)
					balance -= amount;
				else
					ISOException.throwIt(ISO7816.SW_WRONG_DATA);
				break;
			case EPURSE_BAL:
				Util.setShort(buffer,ISO7816.OFFSET_CDATA,balance);
				apdu.setOutgoingAndSend(ISO7816.OFFSET_CDATA,(short)2);
				break;
			default:
				ISOException.throwIt(ISO7816.SW_INS_NOT_SUPPORTED);
		}
	}
}
		
